/* game loop and glue */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "defines.h"
#include "ui.h"
#include "world.h"
#include "lidl.h"

int gameOver;

void gameLoop()
{
  /* main loop for the game */
  uiPrint( "some help: (h)elp, (q)uit" );
  gameOver = FALSE;
  while( !gameOver )
  {
	gamePlayer();
	mapUpdate();
	gameBeasts();
	mapUpdate();
  }
}

void gameAskQuit()
{
  /* Called when a player wishes to quit */
  char gameQuit[2];
  uiInputString( gameQuit, sizeof( gameQuit ), "Are you sure? (y/N)" );
  if( gameQuit[0] == 'y' || gameQuit[0] == 'Y' )
	gameOver = TRUE;
}

void gamePlayer()
{
  /* Called when its the players turn */

  char gamePlayerChoice;
  int gamePlayerDone;
  int gamePlayerMoveOK;
  int gamePlayerPosition[3];
  int gamePlayerNewPosition[3];

  gamePlayerDone = 0;
  playerGetPosition( gamePlayerPosition );
  
  while( !gamePlayerDone && !gameOver )
  {
	gamePlayerChoice = uiInputChar();
	uiDebugPrint( "game.c", "playerchoice = %d", gamePlayerChoice );
	
	if( gamePlayerChoice == 'h' )
	{
	  uiInfoBox( "%s%s%s%s", "Help\n\nWe hope that you are aware that this is\n",
				 "not a finished game, nor playable.\n",
				 "So remember that bugs and other evil\nbeings will come after you, and\n",
				 "currently no monsters ;)\n\n\t- blambi" ); /* FIXME: ugly! */
	}
	else if( gamePlayerChoice <= uiMOVEN && gamePlayerChoice >= uiMOVESE )
	{
	  /* new move code */
	  worldGetMove( gamePlayerNewPosition, gamePlayerPosition[0], gamePlayerPosition[1],
					gamePlayerPosition[2], gamePlayerChoice );
	  
	  gamePlayerMoveOK = playerMove( gamePlayerNewPosition[0], gamePlayerNewPosition[1], gamePlayerNewPosition[2] );

	  uiDebugPrint( "game.c", "moveok = %d", gamePlayerMoveOK );

	  if ( gamePlayerMoveOK == TRUE )
	  {
		gamePlayerDone = TRUE;
	  }
	  else
	  {
		/* find out why */
		uiPrint( "You cant go there" );
	  }
	}
	else if( gamePlayerChoice == 'q' )
	{
	  gameAskQuit();
	}
	/* NOTE: don't add a else since that will just be nagging to misstakes etc... */
  }
}

void gameBeasts()
{
  /* monster ticking etc */

}
