/* Remebers what the player have seen, and the communication with UI */
#include <stdio.h>

#include "defines.h"
#include "ui.h"
#include "world.h"
#include "lidl.h"

int mapSeenMap[ MAPXMAX ][ MAPYMAX ]; /* map of what the player have seen
										 of the world */
/* NOTE: 
   The codes of mapSeenMap is the same as world
   BUT there is one addition code 255 (mapUNSEEN)
   which is used to hide parts ig: unseen parts */

/* FIXME:
   When monster and item code come marching
   we should add them to some kind of map to */

/* FIXME:
   Add support for z (dungeon levels) 
   so the game might gain a "memory" */

void mapInit( void )
{
  /* Inits the map */
  int x, y;
  for( x = 0; x < MAPXMAX; x++ )
	for( y = 0; y < MAPYMAX; y++ )
	{
#ifdef DEBUG
	  mapSeenMap[x +1][y +1] = worldCheckSpot( x, y, 0 ); /* show all if we are
															 debuging */
#else
	  mapSeenMap[x][y] = mapUNSEEN; /* since we are marking the whole map unseen
									   we dont have to pad */
#endif
	}

#ifdef DEBUG
  /* Scan the borders that we missed */
  for( x = 0; x < MAPXMAX; x++ )
	mapSeenMap[x][0] = worldWALL;
 
  for( y = 0; y < MAPYMAX; y++ )
	mapSeenMap[0][y] = worldWALL;
#endif

mapUpdate(); /* to show parts that one should see */
}

void mapUpdate( void )
{
  /* draw the map */
  
  int mapPlayerPosition[3];
  int x, y, z;
  int tx, ty;
  int xmod, ymod;
  int mapPlayerFOV;
  
  playerGetPosition( mapPlayerPosition );
  mapPlayerFOV = playerGetFOV();
  x = mapPlayerPosition[0];
  y = mapPlayerPosition[1];
  z = mapPlayerPosition[2];

  uiDebugPrint( "map.c", "FOV = %d", mapPlayerFOV ); 
  
  /* scan area (around player) */
  for( xmod = mapPlayerFOV / -1; xmod <= mapPlayerFOV; xmod++ )
	for( ymod = mapPlayerFOV / -1; ymod <= mapPlayerFOV; ymod++ )
	{  
	  tx = x + xmod;
	  ty = y + ymod;
	  
	  mapSeenMap[tx +1][ty +1] = worldCheckSpot( tx, ty, z );
	  uiDebugPrint( "map.c", "mapUpdate mapSeenMap[%d][%d] = %d", tx +1, ty +1,
					worldCheckSpot( tx, ty, z ) );

	  if( ymod == 0 && xmod == 0 )
		mapSeenMap[tx +1][ty +1] = mapPLAYER; /* Show where map think we are */

	  uiDebugPrint( "map.c", "xmod = %d, ymod = %d", xmod, ymod );
	}
  uiUpdateMap( mapSeenMap );
}
