/* player stats and related code */
#include <stdio.h>

#include "defines.h"
#include "world.h"
#include "ui.h"
#include "lidl.h"

int playerHp;    /* Health */
int playerMp;    /* Magic Points (POW) */
int playerStr;   /* Strength (STR) */
int playerCon;   /* (CON) */
int playerDex;   /* Dexterity (DEX) */
int playerApp;   /* Appearance (APP) */
int playerSiz;   /* Size (SIZ) */

int playerHpMax;    /* (current) Max Health */
int playerMpMax;    /* (current) Magic Points */

int playerScore;
int playerMoves; /* Nr of moves */
int playerPosition[3];
int playerFOV;

void playerInit()
{
  /* fixes up the default values */

  playerHpMax = playerHp = 100;
  playerMpMax = playerMp = 50;
  playerFOV = 1;
  playerScore = playerMoves = 0;
  worldSpawnPlayer( playerPosition );

#ifdef DEBUG
  uiDebugPrint( "player.c", "playerHp = %d", playerHp );
  uiDebugPrint( "player.c", "playerMp = %d", playerMp );
  uiDebugPrint( "player.c", "playerScore = %d", playerScore );
  uiDebugPrint( "player.c", "playerMoves = %d", playerMoves );
  uiDebugPrint( "player.c", "playerPosition[x] = %d", playerPosition[0] );
  uiDebugPrint( "player.c", "playerPosition[y] = %d", playerPosition[1] );
  uiDebugPrint( "player.c", "playerPosition[z] = %d", playerPosition[2] );
#endif
}

int playerMove( int x, int y, int z )
{
  /* Checks if movement is okey etc and if we move
	 NOTE: Distance is not handeled here */
  int spotcode;

  spotcode = worldCheckSpot(x, y, z);
  
  uiDebugPrint( "player.c", "spotcode = %d", spotcode );

  if( spotcode != worldERROR && spotcode != worldWALL )
  {
	/* then move */
	playerPosition[0] = x;
	playerPosition[1] = y;
	playerPosition[2] = z;
	playerMoves++;
	
	return TRUE;
  }
  else
	return FALSE; /* failed */
}

void playerGetPosition( int *buf )
{
  /* This will return a array whit x,y,z position of
	 the player */
  int step;
  
  for( step = 0; step < 3; step++ )
  {
	uiDebugPrint( "player.c", "buf[%d] = %d", step, playerPosition[step] );
	buf[step] = playerPosition[step];
  }

#ifdef DEBUG
  for( step = 0; step < 3; step++ )
	uiDebugPrint( "player.c", "playerPosition[%d] = %d", step, playerPosition[step] );
#endif
  
}

int playerGetFOV( void )
{
  /* Returns the current Field Of View */
  
  /* TODO: add support for items that burn etc, when items are implented */
  return playerFOV;
}

int playerGetHp( void )
{
  /* Returns the current HP */
  return playerHp;
}

int playerGetHpMax( void )
{
  /* Returns the current max HP */
  return playerHpMax;
}

int playerGetMoves( void )
{
  /* Returns current number of moves/steps */
  return playerMoves;
}
