/* the world */
#include <stdio.h>

#include "defines.h"
#include "ui.h"

int worldMap[ WORLDXMAX ][ WORLDYMAX ]; /* later on it will be 3d but not it will be 2d */

void worldInit( void )
{
  /* init's the world and places a bunch of evil's here and there */
  
  /* clear the cave */
  int x, y;
  for( x = 0; x < WORLDXMAX; x++ )
	for( y = 0; y < WORLDYMAX; y++ )
	{
	  worldMap[x][y] = 0;
	  uiDebugPrint( "world.c", "[%d][%d] = %d", x, y, worldMap[x][y] );
	}
}

void worldSpawnPlayer( int *buf )
{
  /* This function should ONLY be called when a new game starts
	 And ONLY from playerInit
	 Will maybe be converted to a generic worldSpawn function later */

  buf[0] = 0;
  buf[1] = 0;
  buf[2] = 0;
}

int worldCheckSpot( int x, int y, int z )
{
  /* Checks if spot x, y, z is empty or what it is.
	 NOTE: Monsters and Player(s) is not handeled here.
	 return codes:
	 -1 Error worldERROR
	 0  Empty worldEMPTY
	 1  Wall  worldWALL
	 2  Hole  worldHOLE */
  
  int spotcode;

  if(( x >= WORLDXMAX || x < 0 ) || ( y >= WORLDYMAX || y < 0 ))
  {
	uiDebugPrint( "world.c", "something tries to escape the world" );
	return worldWALL; /* the world should be suronded by a unpasable wall */
  }
  
  spotcode = worldMap[x][y];

  uiDebugPrint( "world.c", "spotcode = %d", spotcode );

  if( !( spotcode >= worldEMPTY || spotcode <= worldHOLE ))
  {
	spotcode = worldERROR;

	uiDebugPrint( "world.c", "spotcode error!" );
  }
  
  return spotcode;
}

void worldGetMove( int *buf, int x, int y, int z, int direction )
{
  /* Returns the position for the move 
	 x, y, z is the original position of the thing
	 direction is n, e, w, s used to calculate what spot we
	 are talking about, sadly this code will most likely need
	 a rewrite when the third dimension is introduced
	 (or other stuff like ne)
	 
	 FIXME: we need a system for returns so we will be able to
	 warn the called that the move failed */

  uiDebugPrint( "world.c", "direction = %d", direction );

  buf[2] = z;
  switch( direction )
  {
	case uiMOVEN:
	  buf[0] = x;
	  buf[1] = y - 1;
	  break;
    case uiMOVES:
	  buf[0] = x;
	  buf[1] = y + 1;
	  break;
    case uiMOVEW:
	  buf[1] = y;
	  buf[0] = x - 1;
	  break;
    case uiMOVEE:
	  buf[1] = y;
	  buf[0] = x + 1;
	  break;
    case uiMOVENW:
	  buf[0] = x - 1;
	  buf[1] = y - 1;
	  break;
    case uiMOVENE:
	  buf[0] = x + 1;
	  buf[1] = y - 1;
	  break;
    case uiMOVESW:
	  buf[0] = x - 1;
	  buf[1] = y + 1;
	  break;
    case uiMOVESE:
	  buf[0] = x + 1;
	  buf[1] = y + 1;
	  break;
  }

  uiDebugPrint( "world.c", "target position: %d, %d, %d", buf[0], buf[1], buf[2]);
}
